import os

def main():
    with open("tpl.nw") as template:
        tpl = template.read()
        
    methods = ["LCCD", "CCD", "LCCSD", "CCSD", "CC2", "CCSDT", "CCSD(T)",
               "CCSD[T]", "CR-CCSD(T)", "CR-CCSD[T]", "CCSD(2)_T",
               "LR-CCSD(T)", "QCISD", "QCISD(T)", "CISD", "CISDT",
               "MBPT2", "MBPT3", "MBPT4", "MBPT4(SDQ)", "MBPT4SDQ(T)",
               "LCCSD(T)", "LR-CCSD", "CR-QCISD(T)"]
    #CR-QCISD(T) gave segfault, but only once

    bugs = []
    incompatibles = []
    working = []
    interactive = True

    savedir = "60-2eorb"
    
    for method in sorted(list(set(methods))):
        print(method)
        tcemethod = method.lower()
        deck = tpl.format(tcemethod=tcemethod)
        os.system("rm job/bugtest*")
        os.system("rm job/deck*")
        with open("job/deck.nw", "w") as outfile:
            outfile.write(deck)

        if interactive:
            raw_input("run and then continue: ")
        else:
            cmd = "cd job && nwchem deck.nw &> deck.log"
            os.system(cmd)
        
        with open("job/deck.log") as logfile:
            data = logfile.read()

        if savedir:
            with open("{}/{}.log".format(savedir, tcemethod), "w") as savefile:
                savefile.write(data)

        #failure
        if "AUTHORS" in data:
            working.append(tcemethod)
        elif "method incompatible with 2eorb" in data:
            incompatibles.append(tcemethod)
        elif "hashv2: key not found" in data:
            bugs.append(tcemethod)
        else:
            import ipdb; ipdb.set_trace()

    print "OK", working
    print "Incompatible", incompatibles
    print "Bugs", bugs
               
if __name__ == "__main__":
    main()
